-- Disclaimer
-- Dieser Quellcode ist als Vorlage oder als Ideengeber gedacht. Er kann frei und ohne 
-- Auflagen oder Einschrnkungen verwendet oder verndert werden.
-- Jedoch wird keine Garantie bernommen, das eine Funktionsfhigkeit mit aktuellen und 
-- zuknftigen API-Versionen besteht. Der Autor bernimmt daher keine direkte oder indirekte 
-- Verantwortung, wenn dieser Code gar nicht oder nur fehlerhaft ausgefhrt wird.
-- Fr Anregungen und Fragen stehe ich jedoch gerne zur Verfgung.

-- Thorsten Kansy, www.dotnetconsulting.eu

-- In Datenbank wechseln
USE dotnetconsulting_TSQL2;
GO

-- Erster Wert
-- Sortiert nach Umsatz
SELECT FIRST_VALUE([Umsatz]) OVER (ORDER BY Umsatz), *
FROM [dbo].[Vertriebszahlen];

-- Sortiert nach Umsatz, pro Land
SELECT FIRST_VALUE([Umsatz]) OVER (PARTITION BY Land ORDER BY Umsatz), *
FROM [dbo].[Vertriebszahlen];


-- Letzter Wert
-- Sortiert nach Umsatz
SELECT LAST_VALUE([Umsatz]) OVER (ORDER BY Umsatz), *
FROM [dbo].[Vertriebszahlen];

-- Sortiert nach Umsatz, pro Land
SELECT LAST_VALUE([Umsatz]) OVER (PARTITION BY Land ORDER BY Umsatz)
FROM [dbo].[Vertriebszahlen];

-- SQL Server 2022
SELECT FIRST_VALUE([Umsatz]) IGNORE NULLS OVER (ORDER BY Umsatz), *
FROM [dbo].[Vertriebszahlen];

SELECT FIRST_VALUE([Umsatz]) RESPECT NULLS  OVER (ORDER BY Umsatz), *
FROM [dbo].[Vertriebszahlen];

-- In Version 16.0.900 noch keine Funktion!?
SELECT FIRST_VALUE(Beschreibung) RESPECT NULLS  OVER (ORDER BY ID), *
FROM [dbo].[Produktverzeichnis];

SELECT FIRST_VALUE(Beschreibung) IGNORE NULLS  OVER (ORDER BY ID), *
FROM [dbo].[Produktverzeichnis];

SELECT LAST_VALUE(Beschreibung) RESPECT NULLS  OVER (ORDER BY ID), *
FROM [dbo].[Produktverzeichnis];

SELECT LAST_VALUE(Beschreibung) IGNORE NULLS  OVER (ORDER BY ID), *
FROM [dbo].[Produktverzeichnis];

-- Ab SQL Server 2022+
-- In Version 16.0.900 noch keine Funktion!?
USE AdventureWorks;
GO
SELECT Name, ListPrice,
       FIRST_VALUE(Name) RESPECT NULLS OVER (ORDER BY ListPrice ASC) AS LeastExpensive
FROM Production.Product
WHERE ProductSubcategoryID = 37;

SELECT Name, ListPrice,
       FIRST_VALUE(Name) IGNORE NULLS OVER (ORDER BY ListPrice ASC) AS LeastExpensive
FROM Production.Product
WHERE ProductSubcategoryID = 37;