-- Disclaimer
-- Dieser Quellcode ist als Vorlage oder als Ideengeber gedacht. Er kann frei und ohne 
-- Auflagen oder Einschrnkungen verwendet oder verndert werden.
-- Jedoch wird keine Garantie bernommen, das eine Funktionsfhigkeit mit aktuellen und 
-- zuknftigen API-Versionen besteht. Der Autor bernimmt daher keine direkte oder indirekte 
-- Verantwortung, wenn dieser Code gar nicht oder nur fehlerhaft ausgefhrt wird.
-- Fr Anregungen und Fragen stehe ich jedoch gerne zur Verfgung.

-- Thorsten Kansy, www.dotnetconsulting.eu

-- In Datenbank wechseln
USE dotnetconsulting_TSQL2;
GO

-- Alle gemachten Umstze absteigend sortieren und mit
-- dem nchst niedrigeren Rang vergleichen
;WITH [cte] AS
(
	SELECT TOP 50
		[Name],
		[Umsatz],
		LEAD([Umsatz]) OVER (ORDER BY [Umsatz] DESC) AS 'UnR'
	FROM [dbo].[Vertriebszahlen]
	ORDER BY [Umsatz] DESC
)
SELECT 
	[Name],
	[Umsatz],
	[UnR] AS 'Umsatz nchster Rank',
	[Umsatz] - [UnR] AS 'Delta plus',
	FORMAT(([Umsatz] / [UnR]) - 1, 'P3') AS '% Delta plus'
FROM [cte];